<template>
  <div :class="classObj" class="app-wrapper">
    <div v-if="device==='mobile'&&sidebar.opened" class="drawer-bg" @click="handleClickOutside" />
    <sidebar class="sidebar-container" />
    <div :class="{hasTagsView:needTagsView}" class="main-container">
      <div :class="{'fixed-header':fixedHeader}">
        <navbar />
        <tags-view v-if="needTagsView" />
      </div>
      <app-main />
      <!-- <right-panel v-if="showSettings">
        <settings />
      </right-panel> -->
    </div>
  </div>
</template>

<script>
import RightPanel from '@/components/RightPanel'
import { AppMain, Navbar, Settings, Sidebar, TagsView } from './components'
import ResizeMixin from './mixin/ResizeHandler'
import { mapState } from 'vuex'
import { getToken } from '@/utils/auth'

export default {
  name: 'Layout',
  components: {
    AppMain,
    Navbar,
    RightPanel,
    Settings,
    Sidebar,
    TagsView
  },
  mixins: [ResizeMixin],
  computed: {
    ...mapState({
      sidebar: state => state.app.sidebar,
      device: state => state.app.device,
      showSettings: state => state.settings.showSettings,
      needTagsView: state => state.settings.tagsView,
      fixedHeader: state => state.settings.fixedHeader
    }),
    classObj() {
      return {
        hideSidebar: !this.sidebar.opened,
        openSidebar: this.sidebar.opened,
        withoutAnimation: this.sidebar.withoutAnimation,
        mobile: this.device === 'mobile'
      }
    }
  },
  data(){
    return {
      iswork:null
    }
  },
  created(){
    this.iswork = setInterval(()=>{
      let toke = getToken()
      if(!toke || toke.length <= 0) return;
      this.$axios.get('/admin/index/iswork').then(res=>{
        if(res && res.data.new > 0) {
          this.$notify({
            title: '新的订单提醒',
            duration: 0,
            dangerouslyUseHTMLString: true,
            message: '<strong>你有（'+res.data.new+'）个新的订单，需要处理</strong>'
          });
        }
        if(res && res.data.follow > 0) {
          this.$notify({
            title: '新的跟进提醒',
            duration: 10000,
            dangerouslyUseHTMLString: true,
            message: '<strong>你有（'+res.data.follow+'）个跟进订单，需要处理</strong>'
          });
        }
        if(res && res.data.back > 0) {
          this.$notify({
            title: '转单申请',
            duration: 10000,
            dangerouslyUseHTMLString: true,
            message: '<strong>你有（'+res.data.back+'）个转单订单，需要处理</strong>'
          });
        }
      }).catch(err=>{
        console.log(err)
      })
    },30000);
  },
  methods: {
    handleClickOutside() {
      this.$store.dispatch('app/closeSideBar', { withoutAnimation: false })
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~@/styles/mixin.scss";
  @import "~@/styles/variables.scss";

  .app-wrapper {
    @include clearfix;
    position: relative;
    height: 100%;
    width: 100%;

    &.mobile.openSidebar {
      position: fixed;
      top: 0;
    }
  }

  .drawer-bg {
    background: #000;
    opacity: 0.3;
    width: 100%;
    top: 0;
    height: 100%;
    position: absolute;
    z-index: 999;
  }

  .fixed-header {
    position: fixed;
    top: 0;
    right: 0;
    z-index: 9;
    width: calc(100% - #{$sideBarWidth});
    transition: width 0.28s;
  }

  .hideSidebar .fixed-header {
    width: calc(100% - 54px)
  }

  .mobile .fixed-header {
    width: 100%;
  }
</style>
